Index: branches/PushGP/HeuristicLab.Algorithms.PushGP/HeuristicLab.Tests/Interpreter/Expressions/ExecExpressionTests.cs
===================================================================
--- branches/PushGP/HeuristicLab.Algorithms.PushGP/HeuristicLab.Tests/Interpreter/Expressions/ExecExpressionTests.cs	(revision 14397)
+++ branches/PushGP/HeuristicLab.Algorithms.PushGP/HeuristicLab.Tests/Interpreter/Expressions/ExecExpressionTests.cs	(revision 14398)
@@ -15,8 +15,11 @@
         protected override void Test(Expression expression)
         {
-            this.interpreter.InterpretAsync(expression, true).Wait();
+            interpreter.InterpretAsync(expression, true).Wait();
         }
 
         [TestMethod]
+        [TestProperty("Time", "Short")]
+        [TestCategory("ExpressionTest")]
+        [TestCategory("ExecExpressionTest")]
         public void TestIfTrue()
         {
@@ -25,8 +28,11 @@
 
             Assert.AreEqual("WAHR", interpreter.NameStack.Top);
-            this.TestStackCounts(nameStack: 1);
+            TestStackCounts(nameStack: 1);
         }
 
         [TestMethod]
+        [TestProperty("Time", "Short")]
+        [TestCategory("ExpressionTest")]
+        [TestCategory("ExecExpressionTest")]
         public void TestIfFalse()
         {
@@ -35,8 +41,11 @@
 
             Assert.AreEqual("FALSCH", interpreter.NameStack.Top);
-            this.TestStackCounts(nameStack: 1);
+            TestStackCounts(nameStack: 1);
         }
 
         [TestMethod]
+        [TestProperty("Time", "Short")]
+        [TestCategory("ExpressionTest")]
+        [TestCategory("ExecExpressionTest")]
         public void TestK()
         {
@@ -46,12 +55,15 @@
 
             interpreter.ExecStack.Push(third, second, first);
-            this.Test(new ExecKExpression());
+            Test(new ExecKExpression());
 
             Assert.AreEqual(first, interpreter.ExecStack.Top);
             Assert.AreEqual(third, interpreter.ExecStack.Bottom);
-            this.TestStackCounts(execStack: 2);
+            TestStackCounts(execStack: 2);
         }
 
         [TestMethod]
+        [TestProperty("Time", "Short")]
+        [TestCategory("ExpressionTest")]
+        [TestCategory("ExecExpressionTest")]
         public void TestS()
         {
@@ -62,13 +74,16 @@
 
             interpreter.ExecStack.Push(third, second, first);
-            this.Test(new ExecSExpression());
+            Test(new ExecSExpression());
 
             Assert.AreEqual(result, interpreter.ExecStack.ReverseElementAt(2));
             Assert.AreEqual(third, interpreter.ExecStack.ReverseElementAt(1));
             Assert.AreEqual(first, interpreter.ExecStack.Top);
-            this.TestStackCounts(execStack: 3);
+            TestStackCounts(execStack: 3);
         }
 
         [TestMethod]
+        [TestProperty("Time", "Short")]
+        [TestCategory("ExpressionTest")]
+        [TestCategory("ExecExpressionTest")]
         public void TestY()
         {
@@ -77,12 +92,15 @@
 
             interpreter.ExecStack.Push(first);
-            this.Test(new ExecYExpression());
+            Test(new ExecYExpression());
 
             Assert.AreEqual(first, interpreter.ExecStack.Top);
             Assert.AreEqual(result, interpreter.ExecStack.ReverseElementAt(1));
-            this.TestStackCounts(execStack: 2);
+            TestStackCounts(execStack: 2);
         }
 
         [TestMethod]
+        [TestProperty("Time", "Short")]
+        [TestCategory("ExpressionTest")]
+        [TestCategory("ExecExpressionTest")]
         public void TestNestedDoRange()
         {
@@ -90,8 +108,11 @@
 
             Assert.AreEqual(144, interpreter.IntegerStack.Top);
-            this.TestStackCounts(integerStack: 1);
+            TestStackCounts(integerStack: 1);
         }
 
         [TestMethod]
+        [TestProperty("Time", "Short")]
+        [TestCategory("ExpressionTest")]
+        [TestCategory("ExecExpressionTest")]
         public void TestNestedDoCount()
         {
@@ -99,8 +120,11 @@
 
             Assert.AreEqual(144, interpreter.IntegerStack.Top);
-            this.TestStackCounts(integerStack: 1);
+            TestStackCounts(integerStack: 1);
         }
 
         [TestMethod]
+        [TestProperty("Time", "Short")]
+        [TestCategory("ExpressionTest")]
+        [TestCategory("ExecExpressionTest")]
         public void TestNestedDoTimes()
         {
@@ -108,5 +132,5 @@
 
             Assert.AreEqual(128, interpreter.IntegerStack.Top);
-            this.TestStackCounts(integerStack: 1);
+            TestStackCounts(integerStack: 1);
         }
 
@@ -134,5 +158,5 @@
         protected override void CheckOtherStacksAreEmpty()
         {
-            this.TestStackCounts(execStack: null);
+            TestStackCounts(execStack: null);
         }
     }
Index: branches/PushGP/HeuristicLab.Algorithms.PushGP/HeuristicLab.Tests/Interpreter/Expressions/FloatExpressionTests.cs
===================================================================
--- branches/PushGP/HeuristicLab.Algorithms.PushGP/HeuristicLab.Tests/Interpreter/Expressions/FloatExpressionTests.cs	(revision 14397)
+++ branches/PushGP/HeuristicLab.Algorithms.PushGP/HeuristicLab.Tests/Interpreter/Expressions/FloatExpressionTests.cs	(revision 14398)
@@ -14,4 +14,7 @@
 
         [TestMethod]
+        [TestProperty("Time", "Short")]
+        [TestCategory("ExpressionTest")]
+        [TestCategory("FloatExpressionTest")]
         public void TestAdd()
         {
@@ -21,14 +24,20 @@
             Assert.AreEqual(10.6, interpreter.FloatStack.Top, delta);
 
-            this.TestStackCounts(floatStack: 1);
-        }
-
-        [TestMethod]
+            TestStackCounts(floatStack: 1);
+        }
+
+        [TestMethod]
+        [TestProperty("Time", "Short")]
+        [TestCategory("ExpressionTest")]
+        [TestCategory("FloatExpressionTest")]
         public void TestAddWithInsufficientArguments()
         {
-            this.TestWithInsufficientArguments("+", 1);
-        }
-
-        [TestMethod]
+            TestWithInsufficientArguments("+", 1);
+        }
+
+        [TestMethod]
+        [TestProperty("Time", "Short")]
+        [TestCategory("ExpressionTest")]
+        [TestCategory("FloatExpressionTest")]
         public void TestSubtract()
         {
@@ -38,14 +47,20 @@
             Assert.AreEqual(4.9, interpreter.FloatStack.Top, delta);
 
-            this.TestStackCounts(floatStack: 1);
-        }
-
-        [TestMethod]
+            TestStackCounts(floatStack: 1);
+        }
+
+        [TestMethod]
+        [TestProperty("Time", "Short")]
+        [TestCategory("ExpressionTest")]
+        [TestCategory("FloatExpressionTest")]
         public void TestSubractWithInsufficientArguments()
         {
-            this.TestWithInsufficientArguments("-", 1);
-        }
-
-        [TestMethod]
+            TestWithInsufficientArguments("-", 1);
+        }
+
+        [TestMethod]
+        [TestProperty("Time", "Short")]
+        [TestCategory("ExpressionTest")]
+        [TestCategory("FloatExpressionTest")]
         public void TestMultiply()
         {
@@ -55,14 +70,20 @@
             Assert.AreEqual(32.67, interpreter.FloatStack.Top, delta);
 
-            this.TestStackCounts(floatStack: 1);
-        }
-
-        [TestMethod]
+            TestStackCounts(floatStack: 1);
+        }
+
+        [TestMethod]
+        [TestProperty("Time", "Short")]
+        [TestCategory("ExpressionTest")]
+        [TestCategory("FloatExpressionTest")]
         public void TestMultiplyWithInsufficientArguments()
         {
-            this.TestWithInsufficientArguments("*", 1);
-        }
-
-        [TestMethod]
+            TestWithInsufficientArguments("*", 1);
+        }
+
+        [TestMethod]
+        [TestProperty("Time", "Short")]
+        [TestCategory("ExpressionTest")]
+        [TestCategory("FloatExpressionTest")]
         public void TestDivide()
         {
@@ -72,14 +93,20 @@
             Assert.AreEqual(3.0, interpreter.FloatStack.Top, delta);
 
-            this.TestStackCounts(floatStack: 1);
-        }
-
-        [TestMethod]
+            TestStackCounts(floatStack: 1);
+        }
+
+        [TestMethod]
+        [TestProperty("Time", "Short")]
+        [TestCategory("ExpressionTest")]
+        [TestCategory("FloatExpressionTest")]
         public void TestDivideWithInsufficientArguments()
         {
-            this.TestWithInsufficientArguments("/", 1);
-        }
-
-        [TestMethod]
+            TestWithInsufficientArguments("/", 1);
+        }
+
+        [TestMethod]
+        [TestProperty("Time", "Short")]
+        [TestCategory("ExpressionTest")]
+        [TestCategory("FloatExpressionTest")]
         public void TestModulo()
         {
@@ -89,14 +116,20 @@
             Assert.AreEqual(1, interpreter.FloatStack.Top, delta);
 
-            this.TestStackCounts(floatStack: 1);
-        }
-
-        [TestMethod]
+            TestStackCounts(floatStack: 1);
+        }
+
+        [TestMethod]
+        [TestProperty("Time", "Short")]
+        [TestCategory("ExpressionTest")]
+        [TestCategory("FloatExpressionTest")]
         public void TestModuloWithInsufficientArguments()
         {
-            this.TestWithInsufficientArguments("%", 1);
-        }
-
-        [TestMethod]
+            TestWithInsufficientArguments("%", 1);
+        }
+
+        [TestMethod]
+        [TestProperty("Time", "Short")]
+        [TestCategory("ExpressionTest")]
+        [TestCategory("FloatExpressionTest")]
         public void TestMin()
         {
@@ -106,14 +139,20 @@
             Assert.AreEqual(5.3, interpreter.FloatStack.Top, delta);
 
-            this.TestStackCounts(floatStack: 1);
-        }
-
-        [TestMethod]
+            TestStackCounts(floatStack: 1);
+        }
+
+        [TestMethod]
+        [TestProperty("Time", "Short")]
+        [TestCategory("ExpressionTest")]
+        [TestCategory("FloatExpressionTest")]
         public void TestMinWithInsufficientArguments()
         {
-            this.TestWithInsufficientArguments("MIN", 1);
-        }
-
-        [TestMethod]
+            TestWithInsufficientArguments("MIN", 1);
+        }
+
+        [TestMethod]
+        [TestProperty("Time", "Short")]
+        [TestCategory("ExpressionTest")]
+        [TestCategory("FloatExpressionTest")]
         public void TestMax()
         {
@@ -123,14 +162,20 @@
             Assert.AreEqual(10.3, interpreter.FloatStack.Top, delta);
 
-            this.TestStackCounts(floatStack: 1);
-        }
-
-        [TestMethod]
+            TestStackCounts(floatStack: 1);
+        }
+
+        [TestMethod]
+        [TestProperty("Time", "Short")]
+        [TestCategory("ExpressionTest")]
+        [TestCategory("FloatExpressionTest")]
         public void TestMaxWithInsufficientArguments()
         {
-            this.TestWithInsufficientArguments("MAX", 1);
-        }
-
-        [TestMethod]
+            TestWithInsufficientArguments("MAX", 1);
+        }
+
+        [TestMethod]
+        [TestProperty("Time", "Short")]
+        [TestCategory("ExpressionTest")]
+        [TestCategory("FloatExpressionTest")]
         public void TestSmallerThan()
         {
@@ -140,14 +185,20 @@
             Assert.AreEqual(false, interpreter.BooleanStack.Top);
 
-            this.TestStackCounts(booleanStack: 1);
-        }
-
-        [TestMethod]
+            TestStackCounts(booleanStack: 1);
+        }
+
+        [TestMethod]
+        [TestProperty("Time", "Short")]
+        [TestCategory("ExpressionTest")]
+        [TestCategory("FloatExpressionTest")]
         public void TestSmallerThanWithInsufficientArguments()
         {
-            this.TestWithInsufficientArguments("<", 1);
-        }
-
-        [TestMethod]
+            TestWithInsufficientArguments("<", 1);
+        }
+
+        [TestMethod]
+        [TestProperty("Time", "Short")]
+        [TestCategory("ExpressionTest")]
+        [TestCategory("FloatExpressionTest")]
         public void TestGreaterThan()
         {
@@ -157,14 +208,20 @@
             Assert.AreEqual(true, interpreter.BooleanStack.Top);
 
-            this.TestStackCounts(booleanStack: 1);
-        }
-
-        [TestMethod]
+            TestStackCounts(booleanStack: 1);
+        }
+
+        [TestMethod]
+        [TestProperty("Time", "Short")]
+        [TestCategory("ExpressionTest")]
+        [TestCategory("FloatExpressionTest")]
         public void TestGreaterThanWithInsufficientArguments()
         {
-            this.TestWithInsufficientArguments(">", 1);
-        }
-
-        [TestMethod]
+            TestWithInsufficientArguments(">", 1);
+        }
+
+        [TestMethod]
+        [TestProperty("Time", "Short")]
+        [TestCategory("ExpressionTest")]
+        [TestCategory("FloatExpressionTest")]
         public void TestFromBooleanTrue()
         {
@@ -174,8 +231,11 @@
             Assert.AreEqual(1d, interpreter.FloatStack.Top, delta);
 
-            this.TestStackCounts(floatStack: 1);
-        }
-
-        [TestMethod]
+            TestStackCounts(floatStack: 1);
+        }
+
+        [TestMethod]
+        [TestProperty("Time", "Short")]
+        [TestCategory("ExpressionTest")]
+        [TestCategory("FloatExpressionTest")]
         public void TestFromBooleanFalse()
         {
@@ -185,14 +245,20 @@
             Assert.AreEqual(0d, interpreter.FloatStack.Top, delta);
 
-            this.TestStackCounts(floatStack: 1);
-        }
-
-        [TestMethod]
+            TestStackCounts(floatStack: 1);
+        }
+
+        [TestMethod]
+        [TestProperty("Time", "Short")]
+        [TestCategory("ExpressionTest")]
+        [TestCategory("FloatExpressionTest")]
         public void TestFromBooleanWithInsufficientArguments()
         {
-            this.TestWithInsufficientArguments("FROMBOOLEAN");
-        }
-
-        [TestMethod]
+            TestWithInsufficientArguments("FROMBOOLEAN");
+        }
+
+        [TestMethod]
+        [TestProperty("Time", "Short")]
+        [TestCategory("ExpressionTest")]
+        [TestCategory("FloatExpressionTest")]
         public void TestFromInteger()
         {
@@ -202,14 +268,20 @@
             Assert.AreEqual(5d, interpreter.FloatStack.Top, delta);
 
-            this.TestStackCounts(floatStack: 1);
-        }
-
-        [TestMethod]
+            TestStackCounts(floatStack: 1);
+        }
+
+        [TestMethod]
+        [TestProperty("Time", "Short")]
+        [TestCategory("ExpressionTest")]
+        [TestCategory("FloatExpressionTest")]
         public void TestFromIntegerWithInsufficientArguments()
         {
-            this.TestWithInsufficientArguments("FROMINTEGER");
-        }
-
-        [TestMethod]
+            TestWithInsufficientArguments("FROMINTEGER");
+        }
+
+        [TestMethod]
+        [TestProperty("Time", "Short")]
+        [TestCategory("ExpressionTest")]
+        [TestCategory("FloatExpressionTest")]
         public void TestSine()
         {
@@ -219,14 +291,20 @@
             Assert.AreEqual(1, interpreter.FloatStack.Top, delta);
 
-            this.TestStackCounts(floatStack: 1);
-        }
-
-        [TestMethod]
+            TestStackCounts(floatStack: 1);
+        }
+
+        [TestMethod]
+        [TestProperty("Time", "Short")]
+        [TestCategory("ExpressionTest")]
+        [TestCategory("FloatExpressionTest")]
         public void TestSineWithInsufficientArguments()
         {
-            this.TestWithInsufficientArguments("SIN");
-        }
-
-        [TestMethod]
+            TestWithInsufficientArguments("SIN");
+        }
+
+        [TestMethod]
+        [TestProperty("Time", "Short")]
+        [TestCategory("ExpressionTest")]
+        [TestCategory("FloatExpressionTest")]
         public void TestCosine()
         {
@@ -236,11 +314,14 @@
             Assert.AreEqual(-1, interpreter.FloatStack.Top, delta);
 
-            this.TestStackCounts(floatStack: 1);
-        }
-
-        [TestMethod]
+            TestStackCounts(floatStack: 1);
+        }
+
+        [TestMethod]
+        [TestProperty("Time", "Short")]
+        [TestCategory("ExpressionTest")]
+        [TestCategory("FloatExpressionTest")]
         public void TestCosineWithInsufficientArguments()
         {
-            this.TestWithInsufficientArguments("COS");
+            TestWithInsufficientArguments("COS");
         }
 
@@ -259,5 +340,5 @@
         protected override void CheckOtherStacksAreEmpty()
         {
-            this.TestStackCounts(floatStack: null);
+            TestStackCounts(floatStack: null);
         }
     }
Index: branches/PushGP/HeuristicLab.Algorithms.PushGP/HeuristicLab.Tests/Interpreter/Expressions/IntegerExpressionTests.cs
===================================================================
--- branches/PushGP/HeuristicLab.Algorithms.PushGP/HeuristicLab.Tests/Interpreter/Expressions/IntegerExpressionTests.cs	(revision 14397)
+++ branches/PushGP/HeuristicLab.Algorithms.PushGP/HeuristicLab.Tests/Interpreter/Expressions/IntegerExpressionTests.cs	(revision 14398)
@@ -12,4 +12,7 @@
 
         [TestMethod]
+        [TestProperty("Time", "Short")]
+        [TestCategory("ExpressionTest")]
+        [TestCategory("IntegerExpressionTest")]
         public void TestAdd()
         {
@@ -19,14 +22,20 @@
             Assert.AreEqual(10, interpreter.IntegerStack.Top);
 
-            this.TestStackCounts(integerStack: 1);
-        }
-
-        [TestMethod]
+            TestStackCounts(integerStack: 1);
+        }
+
+        [TestMethod]
+        [TestProperty("Time", "Short")]
+        [TestCategory("ExpressionTest")]
+        [TestCategory("IntegerExpressionTest")]
         public void TestAddWithInsufficientArguments()
         {
-            this.TestWithInsufficientArguments("+", 1);
-        }
-
-        [TestMethod]
+            TestWithInsufficientArguments("+", 1);
+        }
+
+        [TestMethod]
+        [TestProperty("Time", "Short")]
+        [TestCategory("ExpressionTest")]
+        [TestCategory("IntegerExpressionTest")]
         public void TestSubtract()
         {
@@ -36,14 +45,20 @@
             Assert.AreEqual(5, interpreter.IntegerStack.Top);
 
-            this.TestStackCounts(integerStack: 1);
-        }
-
-        [TestMethod]
+            TestStackCounts(integerStack: 1);
+        }
+
+        [TestMethod]
+        [TestProperty("Time", "Short")]
+        [TestCategory("ExpressionTest")]
+        [TestCategory("IntegerExpressionTest")]
         public void TestSubtractWithInsufficientArguments()
         {
-            this.TestWithInsufficientArguments("-", 1);
-        }
-
-        [TestMethod]
+            TestWithInsufficientArguments("-", 1);
+        }
+
+        [TestMethod]
+        [TestProperty("Time", "Short")]
+        [TestCategory("ExpressionTest")]
+        [TestCategory("IntegerExpressionTest")]
         public void TestMultiply()
         {
@@ -53,14 +68,20 @@
             Assert.AreEqual(50, interpreter.IntegerStack.Top);
 
-            this.TestStackCounts(integerStack: 1);
-        }
-
-        [TestMethod]
+            TestStackCounts(integerStack: 1);
+        }
+
+        [TestMethod]
+        [TestProperty("Time", "Short")]
+        [TestCategory("ExpressionTest")]
+        [TestCategory("IntegerExpressionTest")]
         public void TestMultiplyWithInsufficientArguments()
         {
-            this.TestWithInsufficientArguments("*", 1);
-        }
-
-        [TestMethod]
+            TestWithInsufficientArguments("*", 1);
+        }
+
+        [TestMethod]
+        [TestProperty("Time", "Short")]
+        [TestCategory("ExpressionTest")]
+        [TestCategory("IntegerExpressionTest")]
         public void TestDivide()
         {
@@ -70,14 +91,20 @@
             Assert.AreEqual(2, interpreter.IntegerStack.Top);
 
-            this.TestStackCounts(integerStack: 1);
-        }
-
-        [TestMethod]
+            TestStackCounts(integerStack: 1);
+        }
+
+        [TestMethod]
+        [TestProperty("Time", "Short")]
+        [TestCategory("ExpressionTest")]
+        [TestCategory("IntegerExpressionTest")]
         public void TestDivideWithInsufficientArguments()
         {
-            this.TestWithInsufficientArguments("/", 1);
-        }
-
-        [TestMethod]
+            TestWithInsufficientArguments("/", 1);
+        }
+
+        [TestMethod]
+        [TestProperty("Time", "Short")]
+        [TestCategory("ExpressionTest")]
+        [TestCategory("IntegerExpressionTest")]
         public void TestModulo()
         {
@@ -87,14 +114,20 @@
             Assert.AreEqual(0, interpreter.IntegerStack.Top);
 
-            this.TestStackCounts(integerStack: 1);
-        }
-
-        [TestMethod]
+            TestStackCounts(integerStack: 1);
+        }
+
+        [TestMethod]
+        [TestProperty("Time", "Short")]
+        [TestCategory("ExpressionTest")]
+        [TestCategory("IntegerExpressionTest")]
         public void TestModuloWithInsufficientArguments()
         {
-            this.TestWithInsufficientArguments("%", 1);
-        }
-
-        [TestMethod]
+            TestWithInsufficientArguments("%", 1);
+        }
+
+        [TestMethod]
+        [TestProperty("Time", "Short")]
+        [TestCategory("ExpressionTest")]
+        [TestCategory("IntegerExpressionTest")]
         public void TestMin()
         {
@@ -104,14 +137,20 @@
             Assert.AreEqual(5, interpreter.IntegerStack.Top);
 
-            this.TestStackCounts(integerStack: 1);
-        }
-
-        [TestMethod]
+            TestStackCounts(integerStack: 1);
+        }
+
+        [TestMethod]
+        [TestProperty("Time", "Short")]
+        [TestCategory("ExpressionTest")]
+        [TestCategory("IntegerExpressionTest")]
         public void TestMinWithInsufficientArguments()
         {
-            this.TestWithInsufficientArguments("MIN", 1);
-        }
-
-        [TestMethod]
+            TestWithInsufficientArguments("MIN", 1);
+        }
+
+        [TestMethod]
+        [TestProperty("Time", "Short")]
+        [TestCategory("ExpressionTest")]
+        [TestCategory("IntegerExpressionTest")]
         public void TestMax()
         {
@@ -121,14 +160,20 @@
             Assert.AreEqual(10, interpreter.IntegerStack.Top);
 
-            this.TestStackCounts(integerStack: 1);
-        }
-
-        [TestMethod]
+            TestStackCounts(integerStack: 1);
+        }
+
+        [TestMethod]
+        [TestProperty("Time", "Short")]
+        [TestCategory("ExpressionTest")]
+        [TestCategory("IntegerExpressionTest")]
         public void TestMaxWithInsufficientArguments()
         {
-            this.TestWithInsufficientArguments("MAX", 1);
-        }
-
-        [TestMethod]
+            TestWithInsufficientArguments("MAX", 1);
+        }
+
+        [TestMethod]
+        [TestProperty("Time", "Short")]
+        [TestCategory("ExpressionTest")]
+        [TestCategory("IntegerExpressionTest")]
         public void TestSmallerThan()
         {
@@ -138,14 +183,20 @@
             Assert.AreEqual(false, interpreter.BooleanStack.Top);
 
-            this.TestStackCounts(booleanStack: 1);
-        }
-
-        [TestMethod]
+            TestStackCounts(booleanStack: 1);
+        }
+
+        [TestMethod]
+        [TestProperty("Time", "Short")]
+        [TestCategory("ExpressionTest")]
+        [TestCategory("IntegerExpressionTest")]
         public void TestSmallerThanWithInsufficientArguments()
         {
-            this.TestWithInsufficientArguments("<", 1);
-        }
-
-        [TestMethod]
+            TestWithInsufficientArguments("<", 1);
+        }
+
+        [TestMethod]
+        [TestProperty("Time", "Short")]
+        [TestCategory("ExpressionTest")]
+        [TestCategory("IntegerExpressionTest")]
         public void TestGreaterThan()
         {
@@ -155,14 +206,20 @@
             Assert.AreEqual(true, interpreter.BooleanStack.Top);
 
-            this.TestStackCounts(booleanStack: 1);
-        }
-
-        [TestMethod]
+            TestStackCounts(booleanStack: 1);
+        }
+
+        [TestMethod]
+        [TestProperty("Time", "Short")]
+        [TestCategory("ExpressionTest")]
+        [TestCategory("IntegerExpressionTest")]
         public void TestGreaterThanWithInsufficientArguments()
         {
-            this.TestWithInsufficientArguments(">", 1);
-        }
-
-        [TestMethod]
+            TestWithInsufficientArguments(">", 1);
+        }
+
+        [TestMethod]
+        [TestProperty("Time", "Short")]
+        [TestCategory("ExpressionTest")]
+        [TestCategory("IntegerExpressionTest")]
         public void TestFromBooleanTrue()
         {
@@ -172,14 +229,20 @@
             Assert.AreEqual(1, interpreter.IntegerStack.Top);
 
-            this.TestStackCounts(integerStack: 1);
-        }
-
-        [TestMethod]
+            TestStackCounts(integerStack: 1);
+        }
+
+        [TestMethod]
+        [TestProperty("Time", "Short")]
+        [TestCategory("ExpressionTest")]
+        [TestCategory("IntegerExpressionTest")]
         public void TestFromBooleanWithInsufficientArguments()
         {
-            this.TestWithInsufficientArguments("FROMBOOLEAN");
-        }
-
-        [TestMethod]
+            TestWithInsufficientArguments("FROMBOOLEAN");
+        }
+
+        [TestMethod]
+        [TestProperty("Time", "Short")]
+        [TestCategory("ExpressionTest")]
+        [TestCategory("IntegerExpressionTest")]
         public void TestFromBooleanFalse()
         {
@@ -189,8 +252,11 @@
             Assert.AreEqual(0, interpreter.IntegerStack.Top);
 
-            this.TestStackCounts(integerStack: 1);
-        }
-
-        [TestMethod]
+            TestStackCounts(integerStack: 1);
+        }
+
+        [TestMethod]
+        [TestProperty("Time", "Short")]
+        [TestCategory("ExpressionTest")]
+        [TestCategory("IntegerExpressionTest")]
         public void TestFromFloat()
         {
@@ -200,11 +266,14 @@
             Assert.AreEqual(1, interpreter.IntegerStack.Top);
 
-            this.TestStackCounts(integerStack: 1);
-        }
-
-        [TestMethod]
+            TestStackCounts(integerStack: 1);
+        }
+
+        [TestMethod]
+        [TestProperty("Time", "Short")]
+        [TestCategory("ExpressionTest")]
+        [TestCategory("IntegerExpressionTest")]
         public void TestFromFloatWithInsufficientArguments()
         {
-            this.TestWithInsufficientArguments("FROMFLOAT");
+            TestWithInsufficientArguments("FROMFLOAT");
         }
 
@@ -223,5 +292,5 @@
         protected override void CheckOtherStacksAreEmpty()
         {
-            this.TestStackCounts(integerStack: null);
+            TestStackCounts(integerStack: null);
         }
     }
Index: branches/PushGP/HeuristicLab.Algorithms.PushGP/HeuristicLab.Tests/Interpreter/Expressions/NameExpressionTests.cs
===================================================================
--- branches/PushGP/HeuristicLab.Algorithms.PushGP/HeuristicLab.Tests/Interpreter/Expressions/NameExpressionTests.cs	(revision 14397)
+++ branches/PushGP/HeuristicLab.Algorithms.PushGP/HeuristicLab.Tests/Interpreter/Expressions/NameExpressionTests.cs	(revision 14398)
@@ -14,4 +14,7 @@
 
         [TestMethod]
+        [TestProperty("Time", "Short")]
+        [TestCategory("ExpressionTest")]
+        [TestCategory("NameExpressionTest")]
         public void TestRand()
         {
@@ -20,8 +23,11 @@
             Assert.IsTrue(interpreter.NameStack.Count == 1);
 
-            this.CheckOtherStacksAreEmpty();
+            CheckOtherStacksAreEmpty();
         }
 
         [TestMethod]
+        [TestProperty("Time", "Short")]
+        [TestCategory("ExpressionTest")]
+        [TestCategory("NameExpressionTest")]
         public void TestRandomBound()
         {
@@ -34,14 +40,20 @@
             Assert.IsTrue(interpreter.CustomExpressions.Keys.Contains(interpreter.NameStack.Top));
 
-            this.CheckOtherStacksAreEmpty();
+            CheckOtherStacksAreEmpty();
         }
 
         [TestMethod]
+        [TestProperty("Time", "Short")]
+        [TestCategory("ExpressionTest")]
+        [TestCategory("NameExpressionTest")]
         public void TestRandomBoundWithInsufficientArguments()
         {
-            this.TestWithInsufficientArguments("RANDBOUNDNAME");
+            TestWithInsufficientArguments("RANDBOUNDNAME");
         }
 
         [TestMethod]
+        [TestProperty("Time", "Short")]
+        [TestCategory("ExpressionTest")]
+        [TestCategory("NameExpressionTest")]
         public void TestQuote()
         {
@@ -50,5 +62,5 @@
             Assert.IsTrue(interpreter.IsNameQuoteFlagSet);
 
-            this.TestStackCounts();
+            TestStackCounts();
         }
 
@@ -68,5 +80,5 @@
         protected override void CheckOtherStacksAreEmpty()
         {
-            this.TestStackCounts(nameStack: null);
+            TestStackCounts(nameStack: null);
         }
     }
Index: branches/PushGP/HeuristicLab.Algorithms.PushGP/HeuristicLab.Tests/Interpreter/InterpreterTest.cs
===================================================================
--- branches/PushGP/HeuristicLab.Algorithms.PushGP/HeuristicLab.Tests/Interpreter/InterpreterTest.cs	(revision 14397)
+++ branches/PushGP/HeuristicLab.Algorithms.PushGP/HeuristicLab.Tests/Interpreter/InterpreterTest.cs	(revision 14398)
@@ -4,5 +4,5 @@
 namespace HeuristicLab.Tests.Interpreter
 {
-    public class InterpreterTest
+    public class ExpressionTest
     {
         protected PushGPInterpreter interpreter;
